﻿/*
 * BPPair.cs
 * Copyright (c) 2008-2009 kbinani
 *
 * This file is part of Boare.Lib.Vsq.
 *
 * Boare.Lib.Vsq is free software; you can redistribute it and/or
 * modify it under the terms of the BSD License.
 *
 * Boare.Lib.Vsq is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
using System;

namespace Boare.Lib.Vsq {

    /// <summary>
    /// Stores the paired value of "Clock" and integer. Mainly used in VsqBPList
    /// </summary>
    [Serializable]
    public class BPPair : IComparable<BPPair> {
        private int m_clock;
        private int m_value;

        /// <summary>
        /// このインスタンスと、指定したオブジェクトを比較します
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        public int CompareTo( BPPair item ) {
            if ( m_clock > item.Clock ) {
                return 1;
            } else if ( m_clock < item.Clock ) {
                return -1;
            } else {
                return 0;
            }
        }

        /// <summary>
        /// Gets or Sets Clock
        /// </summary>
        public int Clock {
            get {
                return m_clock;
            }
            set {
                m_clock = value;
            }
        }

        /// <summary>
        /// Gets or Sets the Value
        /// </summary>
        public int Value {
            get {
                return m_value;
            }
            set {
                m_value = value;
            }
        }

        public BPPair( int clock, int value ) {
            m_clock = clock;
            m_value = value;
        }
    }

}
